# Method: projects.locations.instances.list

- [HTTP request](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.request_body)
- [Response body](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.ListInstancesResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#body.aspect)
- [Try it!](https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances/list#try-it)

Lists all instances in a project for either a specified location or for all locations.

### HTTP request

`GET https://file.googleapis.com/v1/{parent=projects/*/locations/*}/instances`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The project and location for which to retrieve instance information, in the format `projects/{projectId}/locations/{location}`. In Cloud Filestore, locations map to Google Cloud zones, for example **us-west1-b** . To retrieve instance information for all locations, use "-" for the `{location}` value. |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` The maximum number of items to return. |
| `pageToken` | `string` The nextPageToken value to use if there are additional results to retrieve for this list request. |
| `orderBy` | `string` Sort results. Supported values are "name", "name desc" or "" (unsorted). |
| `filter` | `string` List filter. |

### Request body

The request body must be empty.

### Response body

ListInstancesResponse is the result of ListInstancesRequest.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "instances": [ { object (`https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances#Instance`) } ], "nextPageToken": string, "unreachable": [ string ] } ``` |

| Fields ||
|---|---|
| `instances[]` | ``object (`https://docs.cloud.google.com/filestore/docs/reference/rest/v1/projects.locations.instances#Instance`)`` A list of instances in the project for the specified location. If the `{location}` value in the request is "-", the response contains a list of instances from all locations. If any location is unreachable, the response will only return instances in reachable locations and the "unreachable" field will be populated with a list of unreachable locations. |
| `nextPageToken` | `string` The token you can use to retrieve the next page of results. Not returned if there are no more results in the list. |
| `unreachable[]` | `string` Unordered list. Locations that could not be reached. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).